import { IConnection } from "vscode-languageserver";
import { URI } from "vscode-uri";
import Parser from "web-tree-sitter";
import { CodeLensProvider } from "./providers/codeLensProvider";
import { Settings } from "./util/settings";
export declare class ServerInstance {
    private elmWorkspace;
    private connection;
    private settings;
    private parser;
    codeLensProvider: CodeLensProvider;
    private documentEvents;
    private textDocumentEvents;
    private forest;
    private imports;
    constructor(elmWorkspace: URI, connection: IConnection, settings: Settings, parser: Parser);
    registerInitializedProviders(): Promise<void>;
    init(): Promise<void>;
    private initWorkspace;
    private findElmFilesInFolders;
    private findElmFilesInFolder;
    private packageOrPackagesFolder;
    private findElmHome;
}
